import * as React from 'react';
export declare enum Key {
    TAB = 9,
    ENTER = 13,
    SHIFT = 16,
    ESCAPE = 27,
    LEFT = 37,
    UP = 38,
    RIGHT = 39,
    DOWN = 40,
    A = 65,
    B = 66,
    C = 67,
    D = 68,
    E = 69,
    F = 70,
    G = 71,
    H = 72,
    I = 73,
    J = 74,
    K = 75,
    L = 76,
    M = 77,
    N = 78,
    O = 79,
    P = 80,
    Q = 81,
    R = 82,
    S = 83,
    T = 84,
    U = 85,
    V = 86,
    W = 87,
    X = 88,
    Y = 89,
    Z = 90,
    SLASH = 191,
    QUESTION = 191
}
export declare enum NumKey {
    ZERO = 48,
    ONE = 49,
    TWO = 50,
    THREE = 51,
    FOUR = 52,
    FIVE = 53,
    SIX = 54,
    SEVEN = 55,
    EIGHT = 56,
    NINE = 57
}
export declare enum NumPadKey {
    ZERO = 96,
    ONE = 97,
    TWO = 98,
    THREE = 99,
    FOUR = 100,
    FIVE = 101,
    SIX = 102,
    SEVEN = 103,
    EIGHT = 104,
    NINE = 105
}
export declare type AnyNumKey = NumKey | NumPadKey;
export declare type AnyKeys = AnyNumKey | Key | (AnyNumKey | Key)[];
export declare const useNav: (upperBound: number, init?: number | undefined) => [number, (n: number) => boolean, () => void];
export declare type KeyState = {
    action: KeyAction;
    pressed: boolean;
    group: number;
};
export declare type KeyAction = (keyCode?: number) => boolean;
export declare type KeyMap = {
    [key: number]: KeyState;
};
export declare type KeyHandler = (e: KeyboardEvent) => null;
export declare type KeyFxn = (keys: AnyKeys, action: KeyAction, combo?: boolean) => void;
export interface GroupMap {
    groupForKey: {
        [key: number]: number;
    };
    groups: {
        [group: number]: KeyMap;
    };
    index: number;
}
export declare const useKeyListener: () => (keys: AnyKeys, action: KeyAction, combo?: boolean | undefined) => void;
export declare const useSharedKeyListener: () => GroupMap;
export declare const addKeybinding: (state: GroupMap, keys: AnyKeys, action: KeyAction, combo?: boolean | undefined) => GroupMap;
export declare const NumKeyToNumber: (key: AnyNumKey) => number;
export declare const KeybindingContext: React.Context<{
    keybindingState: GroupMap;
    useKeybinding: KeyFxn;
}>;
export declare const KeybindingProvider: (props: {
    children: React.ReactNode;
}) => JSX.Element;
